#!/usr/bin/perl
# Id: encrypt.pl,v 1.1 2011/02/05 21:09:49 rjs Exp 
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# encryption sample
#

from PDFlib.PLOP import *

# parameters for the input document
in_filename = "PLOP-datasheet.pdf"
in_password = ""

# parameters for the output document
out_filename = "PLOP-datasheet-encrypted.pdf"
out_master = "DEMO"
out_user = "demo"
permissions = ""

# This is where input files live. Adjust as necessary.
searchpath = "../data"

plop = None
try:
    # create a new PLOP object
    plop = PLOP()

    optlist = "searchpath={%s}" % searchpath
    plop.set_option(optlist)

    # open unprotected input file without any password
    optlist = "password {%s} " % in_password
    doc = plop.open_document(in_filename, optlist)
    if (doc == -1):
        raise PLOPException("Error: %s" % plop.get_errmsg(plop))

    # create the output file with a password
    optlist = "masterpassword {%s} userpassword {%s} permissions {%s} input=%d" % \
            (out_master, out_user, permissions, doc)

    if (plop.create_document(out_filename, optlist)== -1):
        raise PLOPException("Error: %s" % plop.get_errmsg(plop))

    # close input and output files
    plop.close_document(doc, "")

except PLOPException as ex:
    print("PDFlib PLOP exception occurred:")
    print("[%d] %s: %s" % (ex.errnum, ex.apiname, ex.errmsg))

except Exception as ex:
    print(ex)

finally:
    if plop:
        plop.delete()
